#include <stdio.h>
#include <stdlib.h>

/* fcat copies data from file at `src` and appends it to
 to the file at `dst`, in 4kb (4096) chunks.
 returns EXIT_SUCCESS or EXIT_FAILURE. */
int fcat(FILE *src, FILE *dst)
{
        int ret = EXIT_FAILURE;
        size_t srcsiz;
        char buf[4096];
        size_t r, w, total = 0;

        fseek(src, 0, SEEK_END);
	srcsiz = ftell(src);
        rewind(src);

        do {
                r = fread(buf, sizeof(char), sizeof(buf), src);
                if (ferror(src))
			goto ABORT;
                else {
                        w = fwrite(buf, sizeof(char), r, dst);
                        if (ferror(dst))
				goto ABORT;
                        total += w;
                }
        } while (!feof(src));

        if (total == srcsiz)
		ret = EXIT_SUCCESS;

ABORT:
        return ret;
}

